# Commit Email Hook

This PHP script is a webhook for gitlab. The hook was created to notify project and group members about a pushed commit.
Gitlab itself has a 'Emails on push' service. But for these service you have to enter the email addresses to a
text field manually.

So the advantages of the hook are:
1. The hook get the project and team members by the gitlab api and dispatches the mails.
2. The hook links to mentioned issues and to the commit itself. So you save time if you want to get more information or want to comment the commit.
3. You can change and style the mail template.
4. You can enable diffs as a file or as an html attachment.
5. You can extend the hook if you need more features.

## Installation

We use composer to manage all required packages. So the first step is to install composer.

```
curl -sS https://getcomposer.org/installer | php
```

If you have root access you can install composer globaly. So you can use composer like this `composer install`.

```
mv composer.phar /usr/local/bin/composer
```

If you do not have the access to do that or don't want to use composer globaly use instead of the composer command
`php /pathToComposer/composer.phar`.

In the second and last step you only have to clone the repository and use composer to install all dependend packages.
That all you need.

```
git clone git@gitlab.sgalinski.de:gitlab/commit-webhook.git webhook
cd webhook
composer install
```

## Configuration

The configuration is as simple as the installation. You only have to copy the example configuration and adjust some
settings. The used configuration language is [YAML](http://symfony.com/doc/current/components/yaml/yaml_format.html).

```
mv config.yaml.example config.yaml
vim config.yaml
```

### GitLab

* Add you Gitlab token to the `authToken` property in the Gitlab section.
* Change the `apiUrl` 'http://gitlab.domain.com/api/v3/' to your domain.

After these changes your webhook is ready to run. But it is recommended to configure the MailConfiguration
section as well. Otherwise your mail recipients get wrong sender information.

### Mail configuration

* Change the email address of the from property to configure the right sender.
* The fallbackRecipient property configures an email address as fallback. E.g. if the API did not get project or group member - the fallback will get the mail. This can be your development leader or someone else.

### Addition configuration

If you want to extend the webhook or test something else you can enable the debugging mode of the webhook.
All emails will send now to the email address that is configured in debugMailAdresse property.
