<?php

/*******************************************************************************
 *
 * Copyright (c) sgalinski Internet Services (http://www.sgalinski.de)
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 ******************************************************************************/

require_once __DIR__ . '/vendor/autoload.php';

use SGalinski\Webhook;
use Symfony\Component\Yaml\Exception\ParseException;
use Symfony\Component\Yaml\Parser;

try {
	/** @var Parser $yamlParser */
	$yamlParser = new Parser();
	$settings = $yamlParser->parse(file_get_contents(__DIR__ . '/config.yaml'));
} catch (ParseException $e) {
	error_log(sprintf('Unable to parse the YAML string: %s', $e->getMessage()));
}

try {
	// read hook request
	$request = file_get_contents('php://input');
	if (!$request) {
		throw new \Exception('Invalid Hook Request (no request information)!');
	}

	$webhook = new Webhook($request, $settings);
	$webhook->processWebhook();
} catch (\Exception $exception) {
	error_log(sprintf('Call Error: "%s"', $exception->getMessage()));
}